=== debian/changelog ===
openrct2 (0.1.2-develop-1) unstable; urgency=medium

  * Release 2017-07 (Closes: #XXXXXX)

 -- Michał Janiszewski <janisozaur+openrct2@gmail.com>  Sun, 10 Jan 2016 23:41:16 +0100
